/*+**********************************************************************************
 * The contents of this file are subject to the vtiger CRM Public License Version 1.0
 * ("License"); You may not use this file except in compliance with the License
 * The Original Code is:  vtiger CRM Open Source
 * The Initial Developer of the Original Code is vtiger.
 * Portions created by vtiger are Copyright (C) vtiger.
 * All Rights Reserved.
 ************************************************************************************/

jQuery.noConflict();

jQuery(document).ready
(
	function()
	{	
		//Get EditView form
		
		var oForm = null;
		
		jQuery('form').each(function(){
			
			if (jQuery(this).attr('name') == 'EditView')
				{
					oForm = jQuery(this);
				}
	
		});
		
		//var oForm = jQuery('form[name="EditView"]');
		
		//Preparing form action
		jQuery(oForm).find("input[name='action']").attr("value", "Save"); 
		
		//Sending form inhibation
		jQuery(oForm).find(".save:button").attr("onclick", "");
		
		//Customizing click action
		jQuery(oForm).find(".save:button").click
		(
			function()
			{
				
				jsv_sendForm(oForm);
			}
		);
	}
)


function jsv_sendForm(oForm)
{	
	
	
	
	//Get EditView form
			
	//Get module name
	var currentModule = jQuery(oForm).find("input[name='module']:last").val();	
	    
	if(formValidate()) //Vtiger function which validate form data
    {   
    	//Testing if a Validation file exists
    	jQuery.ajax
        (
            {
            	url: "index.php?module=" + currentModule + "&action="+currentModule+"AjaxValidation",
                type:'get',
                error: function() //Validation file does not exist
                {
                    jQuery(oForm).submit();
                },
               success: function(data) //Validation file exists
               {
					if(data.search('Module name is missing') == -1 && data.search('Action name is missing') == -1)
					{	                    // Create the path for AJAX Request
					    var phpverif = currentModule + 'AjaxValidation';
					
					    //Create an object which take the values of all input, textarea, select and button elements from the form EditView
					    var myFields = oForm.find(':input');
					    var sentForm = new Object();
					    
					    jQuery.each
					    (
					    	jQuery(myFields), function(key, field)
						    {
						
						        var fieldName = jQuery(field).attr("name");
						        var fieldValue =  jQuery(field).val();
						        
						        if (jQuery(field).attr('type') == 'checkbox')
						        	{
						        		fieldValue =  jQuery(field).attr('checked');
						        	}
						        
						        
						        sentForm[fieldName] = fieldValue;
						    }
					    );
					    
					    
					    				
						//JSONize form data
					    sentForm = JSON.stringify(sentForm);
					    
						//AJAX Request send an JSON object 
						jQuery.ajax
						(
							{
							    type : 'post',
							    data : {structure: sentForm},
							    url : "index.php?module=" + currentModule + "&action=" + phpverif,
							    success : function(msg) //Validation file answers
							    {
							        if (msg.search("%%%CONFIRM%%%") > -1) //Allow to use confirm alert
							    	{
							    		//message to display
							    		var display = msg.split("%%%CONFIRM%%%");
							    		if(confirm(display[1]))//If you click on OK
							    		{
							    			jQuery(oForm).submit();
							    		}
							    		
							    	}
							        else if (msg.search("%%%OK%%%") > -1) //No error
							        {
							            jQuery(oForm).submit();
							        }
							        else //Error
							        {
							            alert(msg);
							        }
							    },
							    error : function() //Error while asking file
							    {
							        alert('Error with AJAX');
							    }
						    }
						);
					}
					else
					{
						jQuery(oForm).submit();
					}
                }
            }
        );
    }
}